# -*- encoding: utf-8 -*-
# stub: xquery 0.2.1 ruby lib

Gem::Specification.new do |s|
  s.name = "xquery".freeze
  s.version = "0.2.1"

  s.required_rubygems_version = Gem::Requirement.new(">= 0".freeze) if s.respond_to? :required_rubygems_version=
  s.require_paths = ["lib".freeze]
  s.authors = ["jelf".freeze]
  s.date = "2017-03-08"
  s.description = "# XQuery\n\n[![Join the chat at https://gitter.im/JelF/xquery](https://badges.gitter.im/Join%20Chat.svg)](https://gitter.im/JelF/xquery?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)\n[![Build Status](https://travis-ci.org/JelF/xquery.svg?branch=master)](https://travis-ci.org/JelF/xquery)\n[![Code Climate](https://codeclimate.com/github/JelF/xquery/badges/gpa.svg)](https://codeclimate.com/github/JelF/xquery)\n[![Test Coverage](https://codeclimate.com/github/JelF/xquery/badges/coverage.svg)](https://codeclimate.com/github/JelF/xquery/coverage)\n[![Issue Count](https://codeclimate.com/github/JelF/xquery/badges/issue_count.svg)](https://codeclimate.com/github/JelF/xquery)  \nXQuery is designed to replace boring method call chains and allow to easier\nconvert it in a builder classes\n## Usage of `XQuery` function\n`XQuery` is a shortcat to `XQuery::Generic.with`\n\n```\nr = XQuery(''.html_safe) do |q|\n  # similar to tap\n  q << 'bla bla bla'\n  q << 'bla bla bla'\n  # using truncate\n  q.truncate(15)\n  # real content (q.send(:query)) mutated\n  q << '!'\nend\nr # => \"bla bla blab...!\"\n```\n## Usage of `XQuery::Abstract`\nI designed this gem to help me with `ActiveRecord` Queries, so i inherited\n`XQuery::Abstract` and used it's powers. It provides the following features\n### `wrap_method` and `wrap_methods`\nwhen you call each of this methods they became automatically wrapped\n(`XQuery::Abstract` basically wraps all methods query `#respond_to?`)\nIt means, that there are instance methods with same name defined and will\nchange a `#query` to their call result.\n```\nself.query = query.foo(x)\n# is basically the same as\nfoo(x)\n# when `wrap_method :foo` called\n```\n\nYou can also specify new name using `wrap_method :foo, as: :bar` syntax\n### `q` object\n`q` is a proxy object which holds all of wrapped methods,\nbut not methods you defined inside your class.\nE.g. i have defined `wrap_method(:foo)`, but also delegated `#foo` to some\nanother object. If i call `q.foo`, i will get wrapped method.\nNote, that if you redefine `#__foo` method, q.foo will call it instead of\nnormal work.\nYou can add additional methods to `q` using something like `alias_on_q :foo`.\nI used it with `kaminary` and it was useful\n```\ndef page=(x)\n  apply { |query| query.page(x) }\nend\nalias_on_q :page=\n\ndef page\n  query.current_page\nend\nalias_on_q :page\n```\n\n### `query_superclass`\nYou should specify `query_superclass` class_attribute to inherit\n`XQuery::Abstract`. Whenever `query.is_a?(query_superclass)` evaluate to false,\nyou will get `XQuery::QuerySuperclassChanged` exception.\nIt can save you much time when your class misconfigured.\nE.g. you are using `select!` and it returns `nil`, because why not?\n\n### `#apply` method\n`#apply` does exact what it source tells\n```\n# yields query inside block\n# @param block [#to_proc]\n# @return [XQuery::Abstract] self\ndef apply(&block)\n  self.query = block.call(query)\n  self\nend\n```\nIt is usefull to merge different queries.\n\n### `with` class method\nYou can get XQuery functionality even you have not defined a specific class\n(You are still have to inherit XQuery::Abstract to use it)\nYou can see it in this document when i described `XQuery` function.\nNote, that it yields a class instance, not `q` object.\nIt accepts any arguments, they will be passed to a constructor (except block)\n\n### `execute` method\nPreferred way to call public instance methods.\nResulting query would be returned\n".freeze
  s.email = ["begdory4+xquery@gmail.com".freeze]
  s.homepage = "https://github.com/JelF/xquery".freeze
  s.licenses = ["WTFPL".freeze]
  s.rubygems_version = "3.2.22".freeze
  s.summary = "XQuery is designed to replace boring method call chains and allow to easier convert it in a builder classes see README.md for more information".freeze

  s.installed_by_version = "3.2.22" if s.respond_to? :installed_by_version

  if s.respond_to? :specification_version then
    s.specification_version = 4
  end

  if s.respond_to? :add_runtime_dependency then
    s.add_runtime_dependency(%q<activesupport>.freeze, [">= 4.0"])
    s.add_development_dependency(%q<bundler>.freeze, ["~> 1.12"])
    s.add_development_dependency(%q<rake>.freeze, ["~> 10.0"])
    s.add_development_dependency(%q<rspec>.freeze, ["~> 3.0"])
    s.add_development_dependency(%q<rubocop>.freeze, ["~> 0.47"])
    s.add_development_dependency(%q<pry>.freeze, ["~> 0.10"])
    s.add_development_dependency(%q<coveralls>.freeze, ["~> 0.8"])
    s.add_development_dependency(%q<yard>.freeze, ["~> 0.9"])
    s.add_development_dependency(%q<launchy>.freeze, ["~> 2.4.3"])
  else
    s.add_dependency(%q<activesupport>.freeze, [">= 4.0"])
    s.add_dependency(%q<bundler>.freeze, ["~> 1.12"])
    s.add_dependency(%q<rake>.freeze, ["~> 10.0"])
    s.add_dependency(%q<rspec>.freeze, ["~> 3.0"])
    s.add_dependency(%q<rubocop>.freeze, ["~> 0.47"])
    s.add_dependency(%q<pry>.freeze, ["~> 0.10"])
    s.add_dependency(%q<coveralls>.freeze, ["~> 0.8"])
    s.add_dependency(%q<yard>.freeze, ["~> 0.9"])
    s.add_dependency(%q<launchy>.freeze, ["~> 2.4.3"])
  end
end
